﻿// Simple class to represent a bouncing ball.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace BouncingBallsWPF
{
    class Ball
    {
        private double x = 0.0;
        private double y = 0.0;
        private double r = 0.0;
        private double velocityX = 0.0;
        private double velocityY = 0.0;

        private Random rand = new Random();

        public Ball(double x, double y, double r)
        {
            this.x = x;
            this.y = y;
            this.r = r;

            this.velocityX = (0.5 - rand.NextDouble()) * 5.0;
            this.velocityY = (0.5 - rand.NextDouble()) * 5.0;
        }

        // Update the position of the ball based on its velocity.
        // Invert the velocity if we hit the wall of our bounding canvas.
        public void updatePosition(double maxX, double maxY)
        {
            x += velocityX;
            y += velocityY;

            if ((x <= r) || (x >= maxX - r))
                velocityX *= -1;
            if ((y <= r) || (y >= maxY - r))
                velocityY *= -1;

        }

        // Return an Ellipse shape that represents where this ball is currently located.
        public Ellipse getEllipse()
        {
            Ellipse ellipse = new Ellipse();
            ellipse.Fill    = Brushes.Red;
            ellipse.Width   = r * 2;
            ellipse.Height  = r * 2;
            Canvas.SetLeft(ellipse, x - r);
            Canvas.SetTop(ellipse, y - r);

            return ellipse;
        }
    }
}
